﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private sv1 As ScrollView
	Private cal As calendar
	Public notedialog As B4XDialog
	Private edt1 As EditText
	Public folder As String
	Public rp As RuntimePermissions
	Public seq As Int = 2	' 1 = mo - su, 2 = su - sa
End Sub
Public Sub Initialize
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Calendar_notes")
	notedialog.Initialize(Root)
	notedialog.PutAtTop = True
	notedialog.BackgroundColor = Colors.LightGray
	notedialog.BodyTextColor = Colors.Blue
	menuitem_toevoegen(Me, "Today")
	menuitem_toevoegen(Me, "Monday-Sunday")
	menuitem_toevoegen(Me, "Sunday-Saturday")
	folder = rp.GetSafeDirDefaultExternal("")
End Sub
Private Sub B4XPage_Appear
	sv1.Panel.RemoveAllViews
	cal.Initialize(Me,"cal")
	Private pnl As Panel
	pnl.Initialize("pnl")
	Dim currentyear As Int = DateTime.GetYear(DateTime.Now)
	Dim toppos As Int = 1dip
	Dim yearnumber As Int = 1
	For y = currentyear -1 To currentyear + 1
		For i = 1 To 12
			pnl = cal.set_month_panel(i,y,seq)	' sequence 1 = mo - su, 2 = su - sa
			sv1.panel.AddView(pnl,1dip,(toppos+pnl.Height*(i-1)),pnl.Width,pnl.Height)
		Next
		sv1.panel.Width = pnl.Width
		sv1.Panel.Height = (pnl.Height * 12) * yearnumber
		toppos = toppos + (pnl.Height * 12)
		yearnumber = yearnumber + 1
	Next
	Private	currentticks As Long = DateTime.Now
	Private currentmonth As Int = DateTime.GetMonth(currentticks)
	Private pos As Int = 1dip + (pnl.Height * 12) + (pnl.Height * (currentmonth-1))
	sv1.ScrollToNow(pos)
End Sub
Private Sub B4XPage_Disappear
	sv1.Panel.RemoveAllViews
End Sub
Private Sub menuitem_toevoegen(objpage As Object, itemname As String)
	Private mnuitem As B4AMenuItem = B4XPages.AddMenuItem(objpage,itemname)
	mnuitem.AddToBar = True
End Sub
Sub B4XPage_MenuClick (Tag As String)
	If Tag = "Today" Then
		B4XPage_Appear
	End If
	If Tag = "Monday-Sunday" Then
		seq = 1
		B4XPage_Appear
	End If
	If Tag = "Sunday-Saturday" Then
		seq = 2
		B4XPage_Appear
	End If
End Sub
Public Sub cal_dayclick
	Private dayticks As Long = cal.lblticks
	Private year As Int = DateTime.GetYear(dayticks)
	Private month As Int = DateTime.GetMonth(dayticks)
	Private day As Int = DateTime.GetDayOfMonth(dayticks)
	Private lst As List
	lst.Initialize
	lst = Array As String("January","February","March","April","May","June","July","August","September","October","November","December")
	DateTime.DateFormat = "dd/MM/yyyy"
	Private strdate  As String = day & " " & lst.Get(month-1) & " " & year
	Private note As String = load_note(dayticks)
	If note = "" Then
		show_add_dialog(strdate)
	Else
		show_change_dialog(note,strdate)	
	End If
End Sub
Sub load_note(ticks As String) As String
	If File.Exists(folder,ticks & "_notes.txt") Then
		Return File.ReadString(folder,ticks & "_notes.txt")
	Else
		Return ""
	End If
End Sub
Sub save_note(ticks As String,note As String)
	File.Delete(folder,ticks & "_notes.txt")
	File.WriteString(folder,ticks & "_notes.txt",note)
End Sub
Private Sub show_add_dialog(strdate As String)
	edt1.Initialize("")
	Dim pnl1 As Panel = setup_dialog("note_dialog",strdate)
	Wait For (notedialog.ShowCustom(pnl1, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If edt1.Text <> "" Then
			save_note(cal.lblticks,edt1.Text)
			sv1.Panel.RemoveAllViews
			B4XPage_Appear
		End If
	End If
End Sub
Private Sub show_change_dialog(note As String, strdate As String)
	Dim pnl1 As Panel = setup_dialog("note_dialog",strdate)
	Dim rs1 As ResumableSub =  notedialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
	edt1.Text = note
	Wait For (rs1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If edt1.Text <> "" Then
			save_note(cal.lblticks,edt1.Text)
		End If
	else if Result = xui.dialogResponse_Negative Then
		File.Delete(folder,cal.lblticks & "_notes.txt")
		sv1.Panel.RemoveAllViews
		B4XPage_Appear
	End If
End Sub
private Sub setup_dialog(strlayout As String,lbltext As String) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 300dip, 190dip)
	pnl.LoadLayout(strlayout)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Gravity = Bit.Or(Gravity.LEFT,Gravity.TOP)
	lbl.Text = lbltext
	lbl.TextSize = 18
	lbl.TextColor = Colors.Black
	lbl.Color = Colors.ARGB(100,182,221,249)
	pnl.AddView(lbl,0,0,340dip,50dip)
	Return pnl
End Sub
